Name:		lfc-postgres
Version:	1.7.3.1
Release:	2%{?dist}
Summary:	LCG File Catalog (LFC) server with postgres database backend

Group:		Applications/Internet
License:	ASL 2.0
URL:		http://glite.web.cern.ch/glite/
#		cvs -d:pserver:anonymous@glite.cvs.cern.ch:/cvs/glite \
#		    co -r LCG-DM_R_1_7_3_1 -d LCG-DM-1.7.3.1 LCG-DM
#		tar --exclude CVS -z -c -f LCG-DM-1.7.3.1.tar.gz LCG-DM-1.7.3.1
Source0:	LCG-DM-%{version}.tar.gz
#		Fix non-standard installation path
#		https://savannah.cern.ch/bugs/?57526
Patch0:		LCG-DM-paths.patch
#		Link using $(CC)
#		https://savannah.cern.ch/bugs/?57527
Patch1:		LCG-DM-ld.patch
#		Fix soname issues
#		https://savannah.cern.ch/bugs/?57528
Patch2:		LCG-DM-withsoname.patch
#		Link binaries using shared libraries
#		https://savannah.cern.ch/bugs/?57529
Patch3:		LCG-DM-shliblink.patch
#		Link to gsoap library, mix parallel build
#		https://savannah.cern.ch/bugs/?57530
Patch4:		LCG-DM-gsoap.patch
#		Fix non-standard install permissions
#		https://savannah.cern.ch/bugs/?57531
Patch5:		LCG-DM-installpermissions.patch
#		Fix init script issues
#		https://savannah.cern.ch/bugs/?57532
Patch6:		LCG-DM-initscripts.patch
#		Fix man page installation
#		https://savannah.cern.ch/bugs/?57533
Patch7:		LCG-DM-man.patch
#		Fix parallel build and other makefile glitches
#		https://savannah.cern.ch/bugs/?57534
Patch8:		LCG-DM-rules.patch
#		Postgres include path
#		https://savannah.cern.ch/bugs/?57535
Patch9:		LCG-DM-posinc.patch
#		Adapt upstream's hardcoded include and library paths for Fedora
Patch10:	LCG-DM-usr.patch
#		Allow moving plugins out of default library search path
Patch11:	LCG-DM-dlopen.patch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires:	gsoap-devel%{?_isa}
BuildRequires:	postgresql-devel%{?_isa}
%if %{?fedora}%{!?fedora:0} >= 12 || %{?rhel}%{!?rhel:0} >= 6
BuildRequires:	libuuid-devel%{?_isa}
%else
BuildRequires:	e2fsprogs-devel%{?_isa}
%endif
BuildRequires:	lcgdm-devel%{?_isa}
BuildRequires:	lfc-devel%{?_isa}
Provides:	lfcdaemon = %{version}-%{release}

Requires(pre):		shadow-utils
Requires(post):		chkconfig
Requires(preun):	chkconfig
Requires(preun):	initscripts
Requires(postun):	initscripts

%description
LCG File Catalog (LFC) server that uses postgres as its database backend

%prep
%setup -q -n LCG-DM-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1

chmod 644 security/globus_gsi_gss_constants.h \
	  security/globus_i_gsi_credential.h \
	  security/gssapi_openssl.h
chmod 644 doc/lfc/INSTALL-*

# Use full path to plugins (see patch #11)
sed 's!@@LIBDIR@@!%{_libdir}!' -i security/Csec_api_loader.c

%build
# The code violates the strict aliasing rules all over the place...
# Need to use -fnostrict-aliasing so that the -O2 optimization in
# optflags doesn't try to use them.
sed 's/^CC +=/& %{optflags} -fno-strict-aliasing/' -i config/linux.cf

gsoapversion=`soapcpp2 -v 2>&1 | grep Compiler | sed 's/.* //'`

./configure lfc --with-postgres \
	--libdir=%{_lib} \
	--with-gsoap-location=%{_prefix} \
	--with-gsoap-version=$gsoapversion \
	--with-voms-location=%{_prefix} \
	--with-id-map-file=%{_sysconfdir}/lcgdm-mapfile \
	--with-ns-config-file=%{_sysconfdir}/NSCONFIG \
	--with-sysconf-dir='$(prefix)/../etc'

sed -e 's/\(BuildDLI	*\)YES/\1NO/' \
    -e 's/\(BuildInterfaces	*\)YES/\1NO/' \
    -e 's/\(BuildNameServerClient	*\)YES/\1NO/' \
    -e 's/\(BuildNameServerLibrary	*\)YES/\1NO/' -i config/site.def

sed '/^\#define.*YES/d' -i config/Project.tmpl config/Library.tmpl
sed '/^SECURITYDIR =/d' -i config/Project.tmpl

echo '#!/bin/sh' > cpp
echo '/lib/cpp -Ui386 "$@"' >> cpp
chmod +x cpp
IMAKECPP=${PWD}/cpp make -f Makefile.ini Makefiles

make %{?_smp_mflags} prefix=%{_prefix}

%install
rm -rf ${RPM_BUILD_ROOT}

make prefix=${RPM_BUILD_ROOT}%{_prefix} install
make prefix=${RPM_BUILD_ROOT}%{_prefix} install.man

mv ${RPM_BUILD_ROOT}%{_datadir}/LFC ${RPM_BUILD_ROOT}%{_datadir}/lfc

mkdir -p ${RPM_BUILD_ROOT}%{_initrddir}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d
mkdir -p ${RPM_BUILD_ROOT}%{_sbindir}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8

mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/lfc-postgres
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}/lfc-postgres

# lfcdaemon startup script
sed -e 's/LD_LIBRARY_PATH=$LD_LIBRARY_PATH //' \
    -e '/LD_LIBRARY_PATH/d' \
    -e 's!/opt/lcg/bin!/usr/sbin!g' -e 's!/opt/lcg!!g' \
    -e 's!\(/var/lock/subsys/\).*!\1lfc-postgres!' \
    -e 's/	/    /g' \
    ${RPM_BUILD_ROOT}%{_datadir}/lfc/rc.lfcdaemon > \
    ${RPM_BUILD_ROOT}%{_initrddir}/lfc-postgres
chmod 755 ${RPM_BUILD_ROOT}%{_initrddir}/lfc-postgres
rm ${RPM_BUILD_ROOT}%{_datadir}/lfc/rc.lfcdaemon

# lfcdaemon configuration file
sed -e 's!/opt/lcg!!g' \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/lfcdaemon.conf.templ > \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/lfc-postgres/lfcdaemon.conf
rm ${RPM_BUILD_ROOT}%{_sysconfdir}/lfcdaemon.conf.templ
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/lfcdaemon

# lfcdaemon log directory and log rotation configuration
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/log/lfc
install -m 644 ns/lfcdaemon.logrotate \
    ${RPM_BUILD_ROOT}%{_sysconfdir}/lfc-postgres/lfcdaemon.logrotate
touch ${RPM_BUILD_ROOT}%{_sysconfdir}/logrotate.d/lfcdaemon

# lfcdaemon binary and man page
mv ${RPM_BUILD_ROOT}%{_bindir}/lfcdaemon \
   ${RPM_BUILD_ROOT}%{_libdir}/lfc-postgres/lfcdaemon
touch ${RPM_BUILD_ROOT}%{_sbindir}/lfcdaemon
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/lfcdaemon
sed -e 's/\(\.TH [^ ]* \)1/\18/' \
    -e 's!/opt/lcg!!g' \
    -e 's/lfc-shutdown(1)/lfc-shutdown(8)/g' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/lfcdaemon.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/lfc-postgres/lfcdaemon.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/lfcdaemon.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/lfcdaemon.8

mv ${RPM_BUILD_ROOT}%{_sysconfdir}/NSCONFIG.templ \
   ${RPM_BUILD_ROOT}%{_libdir}/lfc-postgres/NSCONFIG.templ
touch ${RPM_BUILD_ROOT}%{_datadir}/lfc/NSCONFIG.templ

# lfc-shutdown binary and man page
mv ${RPM_BUILD_ROOT}%{_bindir}/lfc-shutdown \
   ${RPM_BUILD_ROOT}%{_libdir}/lfc-postgres/lfc-shutdown
touch ${RPM_BUILD_ROOT}%{_sbindir}/lfc-shutdown
chmod 755 ${RPM_BUILD_ROOT}%{_sbindir}/lfc-shutdown
sed -e 's/\(\.TH [^ ]* \)1/\18/' \
    ${RPM_BUILD_ROOT}%{_mandir}/man1/lfc-shutdown.1 | gzip -9 -n -c > \
    ${RPM_BUILD_ROOT}%{_libdir}/lfc-postgres/lfc-shutdown.8.gz
rm ${RPM_BUILD_ROOT}%{_mandir}/man1/lfc-shutdown.1
touch ${RPM_BUILD_ROOT}%{_mandir}/man8/lfc-shutdown.8

# Create lfc user home
mkdir -p ${RPM_BUILD_ROOT}%{_localstatedir}/lib/lfc

# Remove files already present in other packages
rm -rf ${RPM_BUILD_ROOT}%{_mandir}/man3
rm -rf ${RPM_BUILD_ROOT}%{_mandir}/man4
rm -rf ${RPM_BUILD_ROOT}%{_includedir}

# Turn off services by default
sed -e 's/\(chkconfig: \)\w*/\1-/' \
    -e '/Default-Start/d' \
    -e 's/\(Default-Stop: *\).*/\10 1 2 3 4 5 6/' \
    -i ${RPM_BUILD_ROOT}%{_initrddir}/lfc-postgres

%clean
rm -rf ${RPM_BUILD_ROOT}

%pre
getent group lfcmgr > /dev/null || groupadd -r lfcmgr
getent passwd lfcmgr > /dev/null || useradd -r -g lfcmgr \
    -d %{_localstatedir}/lib/lfc -s /sbin/nologin -c "LFC Manager" lfcmgr
exit 0

%post
if [ $1 = 1 ]; then
    /sbin/chkconfig --add lfc-postgres
fi
%{_sbindir}/update-alternatives --install %{_sbindir}/lfcdaemon lfcdaemon \
	  %{_libdir}/lfc-postgres/lfcdaemon 10 \
  --slave %{_mandir}/man8/lfcdaemon.8.gz lfcdaemon.8.gz \
	  %{_libdir}/lfc-postgres/lfcdaemon.8.gz \
  --slave %{_datadir}/lfc/NSCONFIG.templ NSCONFIG.templ \
	  %{_libdir}/lfc-postgres/NSCONFIG.templ \
  --slave %{_sysconfdir}/sysconfig/lfcdaemon lfcdaemon.conf \
	  %{_sysconfdir}/lfc-postgres/lfcdaemon.conf \
  --slave %{_sysconfdir}/logrotate.d/lfcdaemon lfcdaemon.logrotate \
	  %{_sysconfdir}/lfc-postgres/lfcdaemon.logrotate \
  --slave %{_sbindir}/lfc-shutdown lfc-shutdown \
	  %{_libdir}/lfc-postgres/lfc-shutdown \
  --slave %{_mandir}/man8/lfc-shutdown.8.gz lfc-shutdown.8.gz \
	  %{_libdir}/lfc-postgres/lfc-shutdown.8.gz \
  --initscript lfc-postgres

%preun
export LANG=C

if [ $1 = 0 ]; then
    %{_sbindir}/update-alternatives --display lfcdaemon | \
	grep currently | grep -q lfc-postgres && \
	/sbin/service lfc-postgres stop > /dev/null 2>&1 || :
    %{_sbindir}/update-alternatives --remove lfcdaemon \
	%{_libdir}/lfc-postgres/lfcdaemon
    /sbin/chkconfig --del lfc-postgres
fi

%postun
if [ $1 -ge 1 ]; then
    %{_sbindir}/update-alternatives --display lfcdaemon | \
	grep currently | grep -q lfc-postgres && \
	/sbin/service lfc-postgres condrestart > /dev/null 2>&1 || :
fi

%files
%defattr(-,root,root,-)
%dir %{_libdir}/lfc-postgres
%{_libdir}/lfc-postgres/lfcdaemon
%ghost %{_sbindir}/lfcdaemon
%{_libdir}/lfc-postgres/lfc-shutdown
%ghost %{_sbindir}/lfc-shutdown
%{_libdir}/lfc-postgres/NSCONFIG.templ
%ghost %{_datadir}/lfc/NSCONFIG.templ
%doc %{_libdir}/lfc-postgres/lfcdaemon.8*
%ghost %{_mandir}/man8/lfcdaemon.8*
%doc %{_libdir}/lfc-postgres/lfc-shutdown.8*
%ghost %{_mandir}/man8/lfc-shutdown.8*
%dir %{_sysconfdir}/lfc-postgres
%config(noreplace) %{_sysconfdir}/lfc-postgres/lfcdaemon.conf
%ghost %{_sysconfdir}/sysconfig/lfcdaemon
%config(noreplace) %{_sysconfdir}/lfc-postgres/lfcdaemon.logrotate
%ghost %{_sysconfdir}/logrotate.d/lfcdaemon
%{_initrddir}/lfc-postgres
%dir %{_datadir}/lfc
%{_datadir}/lfc/create_lfc_tables_postgres.sql
%attr(-,lfcmgr,lfcmgr) %{_localstatedir}/log/lfc
%attr(-,lfcmgr,lfcmgr) %{_localstatedir}/lib/lfc
%doc doc/lfc/INSTALL-server-postgres LICENSE

%changelog
* Mon Nov 23 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.7.3.1-2
- Make dlopening work for standalone

* Tue Sep 22 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.7.3.1-1
- Update to version 1.7.3.1

* Wed Aug 19 2009 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.7.2.5-1
- First build - specfile based on the main lfc package.
